<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCostCompensationReportItem_V3 ArrayType
 * @subpackage Arrays
 */
class ArrayOfCostCompensationReportItem_V3 extends AbstractStructArrayBase
{
    /**
     * The CostCompensationReportItem_V3
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CostCompensationReportItem_V3[]
     */
    public $CostCompensationReportItem_V3;
    /**
     * Constructor method for ArrayOfCostCompensationReportItem_V3
     * @uses ArrayOfCostCompensationReportItem_V3::setCostCompensationReportItem_V3()
     * @param \StructType\CostCompensationReportItem_V3[] $costCompensationReportItem_V3
     */
    public function __construct(array $costCompensationReportItem_V3 = array())
    {
        $this
            ->setCostCompensationReportItem_V3($costCompensationReportItem_V3);
    }
    /**
     * Get CostCompensationReportItem_V3 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CostCompensationReportItem_V3[]|null
     */
    public function getCostCompensationReportItem_V3()
    {
        return isset($this->CostCompensationReportItem_V3) ? $this->CostCompensationReportItem_V3 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCostCompensationReportItem_V3 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCostCompensationReportItem_V3 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCostCompensationReportItem_V3ForArrayConstraintsFromSetCostCompensationReportItem_V3(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCostCompensationReportItem_V3CostCompensationReportItem_V3Item) {
            // validation for constraint: itemType
            if (!$arrayOfCostCompensationReportItem_V3CostCompensationReportItem_V3Item instanceof \StructType\CostCompensationReportItem_V3) {
                $invalidValues[] = is_object($arrayOfCostCompensationReportItem_V3CostCompensationReportItem_V3Item) ? get_class($arrayOfCostCompensationReportItem_V3CostCompensationReportItem_V3Item) : sprintf('%s(%s)', gettype($arrayOfCostCompensationReportItem_V3CostCompensationReportItem_V3Item), var_export($arrayOfCostCompensationReportItem_V3CostCompensationReportItem_V3Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CostCompensationReportItem_V3 property can only contain items of type \StructType\CostCompensationReportItem_V3, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CostCompensationReportItem_V3 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CostCompensationReportItem_V3[] $costCompensationReportItem_V3
     * @return \ArrayType\ArrayOfCostCompensationReportItem_V3
     */
    public function setCostCompensationReportItem_V3(array $costCompensationReportItem_V3 = array())
    {
        // validation for constraint: array
        if ('' !== ($costCompensationReportItem_V3ArrayErrorMessage = self::validateCostCompensationReportItem_V3ForArrayConstraintsFromSetCostCompensationReportItem_V3($costCompensationReportItem_V3))) {
            throw new \InvalidArgumentException($costCompensationReportItem_V3ArrayErrorMessage, __LINE__);
        }
        if (is_null($costCompensationReportItem_V3) || (is_array($costCompensationReportItem_V3) && empty($costCompensationReportItem_V3))) {
            unset($this->CostCompensationReportItem_V3);
        } else {
            $this->CostCompensationReportItem_V3 = $costCompensationReportItem_V3;
        }
        return $this;
    }
    /**
     * Add item to CostCompensationReportItem_V3 value
     * @throws \InvalidArgumentException
     * @param \StructType\CostCompensationReportItem_V3 $item
     * @return \ArrayType\ArrayOfCostCompensationReportItem_V3
     */
    public function addToCostCompensationReportItem_V3(\StructType\CostCompensationReportItem_V3 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CostCompensationReportItem_V3) {
            throw new \InvalidArgumentException(sprintf('The CostCompensationReportItem_V3 property can only contain items of type \StructType\CostCompensationReportItem_V3, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CostCompensationReportItem_V3[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CostCompensationReportItem_V3|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CostCompensationReportItem_V3|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CostCompensationReportItem_V3|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CostCompensationReportItem_V3|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CostCompensationReportItem_V3|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CostCompensationReportItem_V3
     */
    public function getAttributeName()
    {
        return 'CostCompensationReportItem_V3';
    }
}
